---------------------------------------
-- Detlef von Reusner
-- APU and Engine Start Switches for PMDG B737-700
-- FS2020

-- June 27 2022 V1.00 


img_add_fullscreen("bg-day.png")

local gImgSwitch = img_add("switch.png", 157, 52, 50, 50) -- until y == 92
local gImgEngStartLeftSwitch = img_add("rotary-switch.png", 29, 43, 70, 70)
local gImgEngStartRightSwitch = img_add("rotary-switch.png", 279, 43, 70, 70)


EVENT_PMDG_B737_APU_START_ON = 11801
EVENT_PMDG_B737_APU_START_OFF = 11802
EVENT_PMDG_B737_ELECTRICAL_APU_GEN1_OFF = 2802
EVENT_PMDG_B737_ELECTRICAL_APU_GEN2_OFF = 2902

EVENT_PMDG_B737_ENGINE_START_LEFT_DEC = 11908
EVENT_PMDG_B737_ENGINE_START_LEFT_INC = 11907
EVENT_PMDG_B737_ENGINE_START_RIGHT_DEC = 12108
EVENT_PMDG_B737_ENGINE_START_RIGHT_INC = 12107

-- not used


-------------- APU Start Switch ----------------

local gAPUvalue = 0

function cbSetAPUSwitch(v)
-- 0 off, 50 on, 70 start jumped back, 85 start
  -- print(v.. " received")
  gAPUvalue = v
  if v>70 then
    img_move(gImgSwitch, 157, 52 + 40)
  else
    img_move(gImgSwitch, 157, 52 + (40*v/100))
  end
end

fs2020_variable_subscribe("L:switch_118_73X", "Number", cbSetAPUSwitch)

-- old start not working
-- function cbDown()
  -- if gAPUvalue < 50 then
    -- fs2020_variable_write("L:switch_118_73X", "Number", 50)
  -- else
    -- fs2020_variable_write("L:switch_118_73X", "Number", 70)
    -- timer_start(500, 500, 1, function() fs2020_variable_write("L:switch_118_73X", "Number", 85) end)
    -- timer_start(1000, 500, 1, function() fs2020_variable_write("L:switch_118_73X", "Number", 70) end)
    -- timer_start(1300, 500, 1, function() fs2020_variable_write("L:switch_118_73X", "Number", 50) end)
  -- end
-- end
function cbDown()
  if gAPUvalue < 50 then
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_APU_START_ON)
  else
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_APU_START_ON)
--    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_APU_START_START)
  end
end
--button_add("button-visible.png", nil, 143, 105, 111, 40, cbDown, nil)
button_add(nil, nil, 143, 105, 111, 40, cbDown, nil)

-- not working:
-- function cbUp()
  -- if gAPUvalue > 70 then gAPUvalue = 70
  -- elseif gAPUvalue > 50 then gAPUvalue = 50
  -- else
    -- gAPUvalue = 0
  -- end
  -- fs2020_variable_write("L:switch_118_73X", "Number", gAPUvalue)
-- end
function cbUp()
  fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_APU_START_OFF)
end
--button_add("button-visible.png", nil, 143, 33, 111, 40, cbUp, nil)
button_add(nil, nil, 143, 33, 111, 40, cbUp, nil)


------------ Engine Start Switches ----------------------
local gEngLeftValue
local gEngRightValue

function cbTurnEngineStartSwitchLeft(rotac)
  if rotac>0 then
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_ENGINE_START_LEFT_INC)
  else
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_ENGINE_START_LEFT_DEC)
  end
end
dial_add(nil, 30, 45, 70, 70, cbTurnEngineStartSwitchLeft)

function cbSetEngineStartSwitchLeft(v)
-- 0 GRD, 10 OFF, 20 CONT, 30 FLT
  gEngLeftValue = v
  rotate(gImgEngStartLeftSwitch, v*3-30)
end

fs2020_variable_subscribe("L:switch_119_73X", "Number", cbSetEngineStartSwitchLeft)


function cbTurnEngineStartSwitchRight(rotac)
  if rotac>0 then
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_ENGINE_START_RIGHT_INC)
  else
    fs2020_event("K:ROTOR_BRAKE", EVENT_PMDG_B737_ENGINE_START_RIGHT_DEC)
  end
end
dial_add(nil, 280, 45, 70, 70, cbTurnEngineStartSwitchRight)

function cbSetEngineStartSwitchRight(v)
-- 0 GRD, 10 OFF, 20 CONT, 30 FLT
  gEngRightValue = v
  rotate(gImgEngStartRightSwitch, v*3-30)
end
fs2020_variable_subscribe("L:switch_121_73X", "Number", cbSetEngineStartSwitchRight)
