-- PMDG 737-700 FS2020 Autopilot Autothrottle FMC Annunciator

-- V100

-- July 9 2022 - Initial Version - Lvars for active lights not working, only pressing button works

local gImgApReleased = img_add("released.png", 0, 0, 80, 80)
local gImgApPressed = img_add("pressed.png", 0, 0, 80, 80)

local gImgAtReleased = img_add("released.png", 82, 0, 80, 80)
local gImgAtPressed = img_add("pressed.png", 82, 0, 80, 80)

local gImgFmcReleased = img_add("released.png", 164, 0, 80, 80)
local gImgFmcPressed = img_add("pressed.png", 164, 0, 80, 80)



local gApAmber = img_add("ap-amber.png", 0, 0, 80, 80)
local gApRed = img_add("ap-red.png", 0, 0, 80, 80)
local gApOff = img_add("ap-off.png", 0, 0, 80, 80)

local gAtAmber = img_add("at-amber.png", 82, 0, 80, 80)
local gAtRed = img_add("at-red.png", 82, 0, 80, 80)
local gAtOff = img_add("at-off.png", 82, 0, 80, 80)

local gFmcAmber = img_add("fmc-amber.png", 164, 0, 80, 80)
local gFmcOff = img_add("fmc-off.png", 164, 0, 80, 80)

local gApIsPressed = false
local gApColor = gApOff

local gAtIsPressed = false
local gAtColor = gAtOff

local gFmcIsPressed = false
local gFmcColor = gFmcOff

-- ============================= Autopilot ===================

function ShowApAnnunciator()
  visible(gImgApPressed, gApIsPressed)
  visible(gApAmber, false)
  visible(gApRed, false)
  visible(gApOff, false)
  if gApIsPressed then
    move(gApColor, 1, 0)
  else
    move(gApColor, 0, 0)
  end
  visible(gApColor, true)
end

function cbApPressed()
  fs2020_event("ROTOR_BRAKE", 33901)
  gApIsPressed = true
  visible(gImgApPressed, gApIsPressed)
  ShowApAnnunciator()
end

function cbApReleased()
  gApIsPressed = false
  visible(gImgApPressed, gApIsPressed)
  ShowApAnnunciator()
end

button_add(nil, nil, 1, 1, 78, 78, cbApPressed, cbApReleased)

function cbApLightChange(v)
  if v>0 then
    gApColor = gApRed
  else
    gApColor = gApOff
  end
end
ShowApAnnunciator()
fs2020_variable_subscribe("L:switch_3392_73X2", "number", cbApLightChange) -- not working 


-- ================================ Autothrottle ========================

function ShowAtAnnunciator()
  visible(gImgAtPressed, gAtIsPressed)
  visible(gAtAmber, false)
  visible(gAtRed, false)
  visible(gAtOff, false)
  if gAtIsPressed then
    move(gAtColor, 83, 0)
  else
    move(gAtColor, 82, 0)
  end
  visible(gAtColor, true)
end

function cbAtPressed()
  fs2020_event("ROTOR_BRAKE", 34001)
  gAtIsPressed = true
  visible(gImgAtPressed, gAtIsPressed)
  ShowAtAnnunciator()
end

function cbAtReleased()
  gAtIsPressed = false
  visible(gImgAtPressed, gAtIsPressed)
  ShowAtAnnunciator()
end

button_add(nil, nil, 83, 1, 78, 78, cbAtPressed, cbAtReleased)

function cbAtLightChange(amber, red)
  if red>0 then
    gAtColor = gAtRed
  elseif amber>0 then
    gAtColor = gAtAmber
  else
    gAtColor = gAtOff
  end
  ShowAtAnnunciator()
end

ShowAtAnnunciator()
fs2020_variable_subscribe("L:switch_3401_73X", "number", --  amber
  "L:switch_3402_73X", "number", -- red
  cbAtLightChange) -- not working
  
-- ================================ FMC ========================

function ShowFmcAnnunciator()
  visible(gImgFmcPressed, gFmcIsPressed)
  visible(gFmcAmber, false)
  visible(gFmcOff, false)
  if gFmcIsPressed then
    move(gFmcColor, 165, 0)
  else
    move(gFmcColor, 164, 0)
  end
  visible(gFmcColor, true)
end

function cbFmcPressed()
  fs2020_event("ROTOR_BRAKE", 34101)
  gFmcIsPressed = true
  visible(gImgFmcPressed, gFmcIsPressed)
  ShowFmcAnnunciator()
end

function cbFmcReleased()
  gFmcIsPressed = false
  visible(gImgFmcPressed, gFmcIsPressed)
  ShowFmcAnnunciator()
end

button_add(nil, nil, 165, 1, 78, 78, cbFmcPressed, cbFmcReleased)

ShowFmcAnnunciator()

