-- PMDG 737-700 FS2020 APU EGT Gauge

-- Detlef von Reusner
-- V100

-- July 21 2022 - Initial Version


local gPropIllumination = user_prop_get(user_prop_add_enum("Illumination","Day,Night,Dial","Day","Select fix or left forward panel dial controlled illumination"))

local gBgDay = img_add_fullscreen("bg-day.png")

-- these light control variables are automatically set from XPlane datarefs (msfs uncapable right now)
local gDaylight = .0 
local gInteriorLight = .0
local gScalesLight = .5


-- ======================== image order needed for illumination ===============

local gLightMask = img_add_fullscreen("sun-mask.png")
local gBgNight = img_add_fullscreen("bg-night.png")
local gNeedle = img_add("needle.png", 84, 0, 30, 200)
local gNightMask = img_add_fullscreen("sun-mask.png")

-- ======================== Needle rotation =================

fs2020_variable_subscribe("L:switch_35_73X", "number", function(v) img_rotate(gNeedle, v/1100 * 250 - 60, "LOG", 0.05) end)

-- ================== illumination ========================

function cbLightChange()
  -- opacity == 0 means see through
  -- print("daylight: " .. gDaylight .. "   scales: ".. gScalesLight)
  local daylight = var_cap(gDaylight, .1, gDaylight)
  opacity(gLightMask, 1-daylight)
  
  local nightlight = gScalesLight - daylight*1.5
  if nightlight < 0 then
    nightlight = 0
  end
  -- print("nightlight == "..nightlight)
  opacity(gBgNight, nightlight)
  
  local brightness = var_cap(daylight + gScalesLight, .1, 1)
  opacity(gNightMask, 1-brightness)
end

if gPropIllumination == "Day" then
  gDaylight = .99
  gScalesLight = 0
  cbLightChange()
elseif gPropIllumination == "Night" then
  gDaylight = 0
  gScalesLight = .9
  cbLightChange()
else
  fs2020_variable_subscribe("A:LIGHT POTENTIOMETER:2", "Number",  function(v) gDaylight = v; cbLightChange() end)
  fs2020_variable_subscribe("A:LIGHT POTENTIOMETER:3", "Number",  function(v) gScalesLight = v; cbLightChange() end)
  
end
